import { ArrayRga } from '../../../types/rga-array/ArrayRga';
import { BinaryRga } from '../../../types/rga-binary/BinaryRga';
import { ClockDecoder } from '../../../../json-crdt-patch/codec/clock/ClockDecoder';
import { Const } from '../../../types/const/Const';
import { ITimestampStruct } from '../../../../json-crdt-patch/clock';
import { JsonNode } from '../../../types';
import { Model } from '../../../model/Model';
import { ObjectLww } from '../../../types/lww-object/ObjectLww';
import { StringRga } from '../../../types/rga-string/StringRga';
import { ValueLww } from '../../../types/lww-value/ValueLww';
import { ArrayLww } from '../../../types/lww-array/ArrayLww';
export declare class Decoder {
    protected time?: number;
    protected clockDecoder?: ClockDecoder;
    decode(data: unknown[]): Model;
    protected ts(arr: unknown[], index: number): [ITimestampStruct, number];
    protected decodeNode(doc: Model, data: unknown): JsonNode;
    protected decodeObj(doc: Model, data: unknown[]): ObjectLww;
    protected decodeTup(doc: Model, data: unknown[]): ArrayLww;
    protected decodeArr(doc: Model, data: unknown[]): ArrayRga;
    protected decodeStr(doc: Model, data: unknown[]): StringRga;
    protected decodeBin(doc: Model, data: unknown[]): BinaryRga;
    protected decodeVal(doc: Model, data: unknown[]): ValueLww;
    protected decodeConst(doc: Model, data: unknown[]): Const;
    protected decodeConstId(doc: Model, data: unknown[]): Const;
}
