import { ApiPath, ArrayApi, BinaryApi, ConstApi, NodeApi, ObjectApi, StringApi, TupleApi, ValueApi } from './nodes';
import { Patch } from '../../../json-crdt-patch/Patch';
import { PatchBuilder } from '../../../json-crdt-patch/PatchBuilder';
import { JsonNode } from '../../types';
import { ArrayLww } from '../../types/lww-array/ArrayLww';
import { Const } from '../../types/const/Const';
import { ObjectLww } from '../../types/lww-object/ObjectLww';
import { ArrayRga } from '../../types/rga-array/ArrayRga';
import { BinaryRga } from '../../types/rga-binary/BinaryRga';
import { StringRga } from '../../types/rga-string/StringRga';
import { ValueLww } from '../../types/lww-value/ValueLww';
import type { Model } from '../Model';
export declare class ModelApi<Value extends JsonNode = JsonNode> {
    readonly model: Model<Value>;
    builder: PatchBuilder;
    next: number;
    constructor(model: Model<Value>);
    private changeQueued;
    private readonly queueChange;
    private et;
    get events(): EventTarget;
    wrap(node: ValueLww): ValueApi;
    wrap(node: StringRga): StringApi;
    wrap(node: BinaryRga): BinaryApi;
    wrap(node: ArrayRga): ArrayApi;
    wrap(node: ObjectLww): ObjectApi;
    wrap(node: Const): ConstApi;
    wrap(node: ArrayLww): TupleApi;
    wrap(node: JsonNode): NodeApi;
    get node(): NodeApi<Value>;
    get r(): ValueApi<import("../../types/lww-root/RootLww").RootLww<Value>>;
    in(path?: ApiPath): ValueApi<ValueLww<any>>;
    find(path?: ApiPath): JsonNode<unknown>;
    val(path?: ApiPath): ValueApi<ValueLww<any>>;
    tup(path?: ApiPath): TupleApi<ArrayLww<any>>;
    str(path?: ApiPath): StringApi;
    bin(path?: ApiPath): BinaryApi;
    arr(path?: ApiPath): ArrayApi<ArrayRga<any>>;
    obj(path?: ApiPath): ObjectApi<ObjectLww<any>>;
    const(path?: ApiPath): ConstApi<Const<any>>;
    root(json: unknown): this;
    apply(): void;
    advance(): void;
    view(): unknown;
    flush(): Patch;
}
