import { ArrayRga } from '../../types/rga-array/ArrayRga';
import { ObjectLww } from '../../types/lww-object/ObjectLww';
import { toPath } from '../../../json-pointer';
import { ArrayLww } from '../../types/lww-array/ArrayLww';
export const find = (startNode, path) => {
    const steps = toPath(path);
    let node = startNode;
    const length = steps.length;
    if (!length)
        return node;
    let i = 0;
    while (i < length && node) {
        const step = steps[i++];
        node = node.container();
        if (!node)
            throw new Error('NOT_CONTAINER');
        if (node instanceof ObjectLww) {
            const nextNode = node.get(String(step));
            if (!nextNode)
                throw new Error('NOT_FOUND');
            node = nextNode;
        }
        else if (node instanceof ArrayRga) {
            const nextNode = node.getNode(Number(step));
            if (!nextNode)
                throw new Error('NOT_FOUND');
            node = nextNode;
        }
        else if (node instanceof ArrayLww) {
            const nextNode = node.get(Number(step));
            if (!nextNode)
                throw new Error('NOT_FOUND');
            node = nextNode;
        }
    }
    return node;
};
