import type { Identifiable } from '../../json-crdt-patch/Identifiable';
export interface JsonNode<View = unknown> extends Identifiable {
    view(): View;
    children(callback: (node: JsonNode) => void): void;
    child?(): JsonNode | undefined;
    container(): JsonNode | undefined;
    api: undefined | unknown;
}
export type JsonNodeView<N> = N extends JsonNode<infer V> ? V : {
    [K in keyof N]: JsonNodeView<N[K]>;
};
